#ifndef OVAL_DEFINITIONS
#define OVAL_DEFINITIONS

	enum Oval_family
		{FAMILY_AIX, FAMILY_APACHE, FAMILY_CATOS, FAMILY_ESX, FAMILY_FREEBSD,
		 FAMILY_HPUX, FAMILY_INDEPENDENT, FAMILY_LINUX, FAMILY_MACOS, FAMILY_PIXOS,
		 FAMILY_SOLARIS, FAMILY_UNIX, FAMILY_WINDOWS};

	struct Oval_affected{
		int    family;/*Oval_family*/
		char** platform;
		char** product;
	};

	struct Oval_reference{
		char* source;
		char* ref_id;
		char* ref_url;
	};

	enum Oval_class {CLASS_COMPLIANCE, CLASS_INVENTORY, CLASS_MISCELLANEOUS, CLASS_PATCH, CLASS_VULNERABILITY};

	struct Oval_criteria;

	struct Oval_definition{

		/*attributes*/
		char* id;
		int  version;
		int  class;/*Oval_class*/
		char deprecated;
		char pad[3];

		/*metadata*/
		char* title;
		char* description;
		struct Oval_affected ** affected;
		struct Oval_reference** references;

		/*criteria*/
		struct Oval_criteria* criteria;

	};

	enum Oval_criteria_node_type{NODETYPE_CRITERIA, NODETYPE_CRITERION, NODETYPE_EXTENDDEF};

	struct Oval_criteria_node{
		char node_type; /*Oval_criteria_node_type*/
		char negate;
		char* comment;
	};

	enum Oval_operator{AND, ONE, OR, XOR};

	struct Oval_criteria{/*extends Oval_criteria_node*/
		char node_type; /*Oval_criteria_node_type == NODETYPE_CRTERIA*/
		char negate;
		char pad[2];
		char* comment;
		int operator;/*Oval_operator*/
		struct Oval_criteria_node** subnodes;
	};

	struct Oval_test;

	struct Oval_criterion{/*extends Oval_criteria_node*/
		char node_type; /*Oval_criteria_node_type == NODETYPE_CRTERION*/
		char negate;
		char pad[2];
		char* comment;
	};

	struct Oval_extend_definition{/*extends Oval_criteria_node*/
		char node_type; /*Oval_criteria_node_type == NODETYPE_EXTENDDEF*/
		char negate;
		char pad[2];
		char* comment;
		struct Oval_definition* extended_definition;
	};

	enum Oval_existence {ALL_EXIST, ANY_EXIST, AT_LEAST_ONE_EXISTS, ONLY_ONE_EXISTS};
	enum Oval_check {ALL, AT_LEAST_ONE, NONE_EXIST, NONE_SATISFY, ONLY_ONE};

	struct Oval_object{
		int family;/*Oval_family*/
		char* object_name;
		char** notes;
		char* comment;
		char* id;
		char  deprecated;
		int   version;
	};

	struct oval_test{
		int family;/*Oval_family*/
		int catagory;/*Family dependent category*/
		char*  test_name;
		char** notes;
		char*  comment;
		char* id;
		char deprecated;
		int   version;
		char operator;/*Oval_operator*/
		int   existence;/*Oval_existence*/
		int   check;/*Oval_check*/

		struct Oval_object* object;
		struct Oval_state*  state;
	};

#endif
